﻿
public interface I1 {
	void f();
}

internal interface I2 {
	void g();
}

// Both f and g are accessible outside of this assembly.
public class A : I1, I2 {
	public void f() {
		Console.WriteLine("A.f()");
	}

	public void g() {
		Console.WriteLine("A.f()");
	}
}

// Only f is accessible outside of this assembly. The g is sort of "internal".
public class B : I1, I2 {
	public void f() {
		Console.WriteLine("B.f()");
	}

	void I2.g() {
		Console.WriteLine("B.f()");
	}
}

// C.X.f is accessible outside of this assembly. C.X.g is accessible only from C and X (via C's private interface I3).
// C.X.h is accessible only from X (not from C!)
public class C {
	private interface I3 {
		void g();
	}

	public class X : I1, I3 {
		public void f() {
			Console.WriteLine("C.X.f()");
		}

		void I3.g() {
			Console.WriteLine("C.X.g()");
		}

		private void h() {
			Console.WriteLine("C.X.h()");
		}
	}
}

class Program {
	static void Main(string[] args) {
		A a = new A();
		a.f();
		a.g();

		B b = new B();
		b.f();
		// b.g();			// Compile error
		((I2) b).g();

		C.X x = new C.X();
		x.f();
		// x.g();			// Compile error
		// ((C.I3) x).g();	// Compile error
	}
}

