﻿// #define WITH_DUMMY

using System;

using System.Collections.Generic;
using System.Collections;

using MyExtensionsOfA;

namespace EnumerableViaExtensionMethodCSharp9 {
	class A {
	}

	class Program {
		static void Main(string[] args) {
			var a = new A();

			Console.WriteLine("before foreach");
			foreach (var i in a) {
				Console.WriteLine(i);
			}
			Console.WriteLine("after foreach");
		}
	}
}

namespace MyExtensionsOfA {
	static class AExtensions {
#if !WITH_DUMMY
		public static IEnumerator<int> GetEnumerator(this EnumerableViaExtensionMethodCSharp9.A a) {
			return new AEnumerator();
		}
#endif

		private class AEnumerator : IEnumerator<int> {
			public int Current { get; private set; }

			object IEnumerator.Current {
				get {
					return this.Current;
				}
			}

			public void Dispose() {
			}

			public bool MoveNext() {
				if (Current <= 5) {
					Current++;
					Console.WriteLine("AExtensions.AEnumerator.MoveNext() -> true");
					return true;
				} else {
					Console.WriteLine("AExtensions.AEnumerator.MoveNext() -> false");
					return false;
				}
			}

			public void Reset() {
				Current = 0;
			}
		}

#if WITH_DUMMY
		public static IEnumerator<int> GetEnumerator(this EnumerableViaExtensionMethodCSharp9.A a, int dummy = 42) {
			return new AEnumerator();
		}
#endif
	}
}
